#define _GNU_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "libpq-fe.h"

#include "config.h"

int main()
{
	PGconn *conn;
	PGresult *res,*res1;
	char *query;
	int i,j;

	query=(char *) malloc(302);
	conn=PQsetdbLogin(DBHOST,NULL,NULL,NULL,DBNAME,DBUSER,DBPASS);
	res=PQexec(conn,"select value from config where name='acct_chain_pfx'");
	for (i=0;i<PQntuples(res);i++)
	{

		printf("%s -F %s_in\n",IPCHAINS,PQgetvalue(res,i,0));
		printf("%s -F %s_out\n",IPCHAINS,PQgetvalue(res,i,0));
		snprintf(query,300,"select value from config where name='free_zone'");
		res1=PQexec(conn,query);
		for (j=0;j<PQntuples(res1);j++)
		{
			printf("%s -A %s_in -d %s -j RETURN\n",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res1,j,0));
			printf("%s -A %s_out -s %s -j RETURN\n",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res1,j,0));
		}

		snprintf(query,300,"select value from config where name='acct_src'");
		res1=PQexec(conn,query);
		for (j=0;j<PQntuples(res1);j++)
		{
			printf("%s -A %s_in -s %s\n",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res1,j,0));
			printf("%s -A %s_out -d %s\n",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res1,j,0));
		}
		snprintf(query,300,"select srcip,srcport,dstip,dstport,proto,iface,rule,prio from %s_in order by prio",PQgetvalue(res,i,0));
		res1=PQexec(conn,query);
		for (j=0;j<PQntuples(res1);j++)
		{
			snprintf(query,290,"%s -A %s_in -s %s -d %s",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res1,j,0),PQgetvalue(res1,j,2));


			if (strlen(PQgetvalue(res1,j,1))>0)
			{
				strcat(query," --source-port ");
				strcat(query,PQgetvalue(res1,j,1));
			}

			if (strlen(PQgetvalue(res1,j,3))>1)
			{
				strcat(query," --destination-port ");
				strcat(query,PQgetvalue(res1,j,3));
			}

			if (strlen(PQgetvalue(res1,j,4))>0)
			{
				strcat(query," --protocol ");
				strcat(query,PQgetvalue(res1,j,4));
			}
			if (strlen(PQgetvalue(res1,j,5))>0)
			{
				strcat(query," --interface ");
				strcat(query,PQgetvalue(res1,j,5));
			}
			if (strlen(PQgetvalue(res1,j,6))>0)
			{
				strcat(query," -j ");
				strcat(query,PQgetvalue(res1,j,6));
			}


			printf("%s\n",query);
		}
		snprintf(query,300,"select srcip,srcport,dstip,dstport,proto,iface,rule,prio from %s_out order by prio",PQgetvalue(res,i,0));
		res1=PQexec(conn,query);
		for (j=0;j<PQntuples(res1);j++)
		{
			snprintf(query,290,"%s -A %s_out -s %s -d %s",IPCHAINS,PQgetvalue(res,i,0),PQgetvalue(res1,j,0),PQgetvalue(res1,j,2));


			if (strlen(PQgetvalue(res1,j,1))>0)
			{
				strcat(query," --source-port ");
				strcat(query,PQgetvalue(res1,j,1));
			}

			if (strlen(PQgetvalue(res1,j,3))>1)
			{
				strcat(query," --destination-port ");
				strcat(query,PQgetvalue(res1,j,3));
			}

			if (strlen(PQgetvalue(res1,j,4))>0)
			{
				strcat(query," --protocol ");
				strcat(query,PQgetvalue(res1,j,4));
			}
			if (strlen(PQgetvalue(res1,j,5))>0)
			{
				strcat(query," --interface ");
				strcat(query,PQgetvalue(res1,j,5));
			}
			if (strlen(PQgetvalue(res1,j,6))>0)
			{
				strcat(query," -j ");
				strcat(query,PQgetvalue(res1,j,6));
			}


			printf("%s\n",query);
		}


	}
	printf("%s -F ifc_in\n",IPCHAINS);
        printf("%s -F ifc_out\n",IPCHAINS);
	res=PQexec(conn,"select value from config where name='acct_iface'");
	for (i=0;i<PQntuples(res);i++)
	{

		printf("%s -A ifc_in --interface %s\n",IPCHAINS,PQgetvalue(res,i,0));
		printf("%s -A ifc_out --interface %s\n",IPCHAINS,PQgetvalue(res,i,0));

	}



	PQfinish(conn);
	return 0;
}